#include <bits/stdc++.h>
using namespace std;
using namespace std;
typedef long long ll;
typedef vector <int> vi;
typedef pair <int,int> pii;
typedef pair<ll,ll> pll;
typedef vector<ll> vll;
#define A first
#define B second
#define PB push_back
#define MP make_pair
#define PF push_front
#define all(v) v.begin(),v.end()
#define FAST ios_base::sync_with_stdio(false),cin.tie(0),cout.tie(0);


int main()
{
    FAST
    int n,m;
    cin>>n>>m;
    int mat[n][m];
    for(int i=0;i<n;i++) for(int j=0;j<m;j++) cin>>mat[i][j];
    int q;
    cin>>q;
    while(q--)
    {
        int x,y;
        cin>>x>>y;
        int res[n][m];
        res[0][0]=mat[0][0];
        x--;
        y--;
        res[x][y]=INT_MAX;
        for(int i=1;i<n;i++)
        {
            if(i!=x || y!=0)
            {
                if(y==0 && i>x) res[i][0]=INT_MAX;
                else res[i][0]=res[i-1][0]+mat[i][0];
            }
        }
        for(int i=1;i<m;i++)
        {
            if(i!=y || x!=0)
            {
                if(x==0 && i>y) res[0][i]=INT_MAX;
                else res[0][i]=res[0][i-1]+mat[0][i];
            }
        }
        for(int i=1;i<n;i++) for(int j=1;j<m;j++) if(i!=x || j!=y) res[i][j]=min(res[i-1][j],res[i][j-1])+mat[i][j];
        cout<<res[n-1][m-1]<<endl;
    }
    return 0;
}